// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	. "gitlab.com/commonground/nlx/fsc-nlx/txlog-api/ports/rest/api/models"
)

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// ListMetadataRecords request
	ListMetadataRecords(ctx context.Context, transactionID Uuid, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateMetadataRecordsWithBody request with any body
	CreateMetadataRecordsWithBody(ctx context.Context, transactionID Uuid, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateMetadataRecords(ctx context.Context, transactionID Uuid, body CreateMetadataRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetHealth request
	GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetLogRecords request
	GetLogRecords(ctx context.Context, params *GetLogRecordsParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateLogRecordsWithBody request with any body
	CreateLogRecordsWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateLogRecords(ctx context.Context, body CreateLogRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) ListMetadataRecords(ctx context.Context, transactionID Uuid, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewListMetadataRecordsRequest(c.Server, transactionID)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateMetadataRecordsWithBody(ctx context.Context, transactionID Uuid, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateMetadataRecordsRequestWithBody(c.Server, transactionID, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateMetadataRecords(ctx context.Context, transactionID Uuid, body CreateMetadataRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateMetadataRecordsRequest(c.Server, transactionID, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetHealthRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetLogRecords(ctx context.Context, params *GetLogRecordsParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetLogRecordsRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateLogRecordsWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateLogRecordsRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateLogRecords(ctx context.Context, body CreateLogRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateLogRecordsRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewListMetadataRecordsRequest generates requests for ListMetadataRecords
func NewListMetadataRecordsRequest(server string, transactionID Uuid) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "transactionID", runtime.ParamLocationPath, transactionID)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/metadata/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateMetadataRecordsRequest calls the generic CreateMetadataRecords builder with application/json body
func NewCreateMetadataRecordsRequest(server string, transactionID Uuid, body CreateMetadataRecordsJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateMetadataRecordsRequestWithBody(server, transactionID, "application/json", bodyReader)
}

// NewCreateMetadataRecordsRequestWithBody generates requests for CreateMetadataRecords with any type of body
func NewCreateMetadataRecordsRequestWithBody(server string, transactionID Uuid, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "transactionID", runtime.ParamLocationPath, transactionID)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/metadata/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("PUT", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewGetHealthRequest generates requests for GetHealth
func NewGetHealthRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/health")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetLogRecordsRequest generates requests for GetLogRecords
func NewGetLogRecordsRequest(server string, params *GetLogRecordsParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/logs")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Cursor != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "cursor", runtime.ParamLocationQuery, *params.Cursor); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Limit != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "limit", runtime.ParamLocationQuery, *params.Limit); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.SortOrder != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "sort_order", runtime.ParamLocationQuery, *params.SortOrder); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.After != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "after", runtime.ParamLocationQuery, *params.After); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Before != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "before", runtime.ParamLocationQuery, *params.Before); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "group_id", runtime.ParamLocationQuery, params.GroupId); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if params.GrantHash != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "grant_hash", runtime.ParamLocationQuery, *params.GrantHash); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ServiceName != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "service_name", runtime.ParamLocationQuery, *params.ServiceName); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.TransactionIds != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "transaction_ids", runtime.ParamLocationQuery, *params.TransactionIds); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.PeerId != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "peer_id", runtime.ParamLocationQuery, *params.PeerId); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateLogRecordsRequest calls the generic CreateLogRecords builder with application/json body
func NewCreateLogRecordsRequest(server string, body CreateLogRecordsJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateLogRecordsRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateLogRecordsRequestWithBody generates requests for CreateLogRecords with any type of body
func NewCreateLogRecordsRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/logs")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// ListMetadataRecordsWithResponse request
	ListMetadataRecordsWithResponse(ctx context.Context, transactionID Uuid, reqEditors ...RequestEditorFn) (*ListMetadataRecordsResponse, error)

	// CreateMetadataRecordsWithBodyWithResponse request with any body
	CreateMetadataRecordsWithBodyWithResponse(ctx context.Context, transactionID Uuid, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateMetadataRecordsResponse, error)

	CreateMetadataRecordsWithResponse(ctx context.Context, transactionID Uuid, body CreateMetadataRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateMetadataRecordsResponse, error)

	// GetHealthWithResponse request
	GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error)

	// GetLogRecordsWithResponse request
	GetLogRecordsWithResponse(ctx context.Context, params *GetLogRecordsParams, reqEditors ...RequestEditorFn) (*GetLogRecordsResponse, error)

	// CreateLogRecordsWithBodyWithResponse request with any body
	CreateLogRecordsWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateLogRecordsResponse, error)

	CreateLogRecordsWithResponse(ctx context.Context, body CreateLogRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateLogRecordsResponse, error)
}

type ListMetadataRecordsResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *struct {
		// Records List of metadata records
		Records []Metadata `json:"records"`
	}
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r ListMetadataRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ListMetadataRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateMetadataRecordsResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r CreateMetadataRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateMetadataRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetHealthResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r GetHealthResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetHealthResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetLogRecordsResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *struct {
		Pagination PaginationResult `json:"pagination"`

		// Records List of log records
		Records []LogRecord `json:"records"`
	}
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r GetLogRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetLogRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateLogRecordsResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r CreateLogRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateLogRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// ListMetadataRecordsWithResponse request returning *ListMetadataRecordsResponse
func (c *ClientWithResponses) ListMetadataRecordsWithResponse(ctx context.Context, transactionID Uuid, reqEditors ...RequestEditorFn) (*ListMetadataRecordsResponse, error) {
	rsp, err := c.ListMetadataRecords(ctx, transactionID, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseListMetadataRecordsResponse(rsp)
}

// CreateMetadataRecordsWithBodyWithResponse request with arbitrary body returning *CreateMetadataRecordsResponse
func (c *ClientWithResponses) CreateMetadataRecordsWithBodyWithResponse(ctx context.Context, transactionID Uuid, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateMetadataRecordsResponse, error) {
	rsp, err := c.CreateMetadataRecordsWithBody(ctx, transactionID, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateMetadataRecordsResponse(rsp)
}

func (c *ClientWithResponses) CreateMetadataRecordsWithResponse(ctx context.Context, transactionID Uuid, body CreateMetadataRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateMetadataRecordsResponse, error) {
	rsp, err := c.CreateMetadataRecords(ctx, transactionID, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateMetadataRecordsResponse(rsp)
}

// GetHealthWithResponse request returning *GetHealthResponse
func (c *ClientWithResponses) GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error) {
	rsp, err := c.GetHealth(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetHealthResponse(rsp)
}

// GetLogRecordsWithResponse request returning *GetLogRecordsResponse
func (c *ClientWithResponses) GetLogRecordsWithResponse(ctx context.Context, params *GetLogRecordsParams, reqEditors ...RequestEditorFn) (*GetLogRecordsResponse, error) {
	rsp, err := c.GetLogRecords(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetLogRecordsResponse(rsp)
}

// CreateLogRecordsWithBodyWithResponse request with arbitrary body returning *CreateLogRecordsResponse
func (c *ClientWithResponses) CreateLogRecordsWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateLogRecordsResponse, error) {
	rsp, err := c.CreateLogRecordsWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateLogRecordsResponse(rsp)
}

func (c *ClientWithResponses) CreateLogRecordsWithResponse(ctx context.Context, body CreateLogRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateLogRecordsResponse, error) {
	rsp, err := c.CreateLogRecords(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateLogRecordsResponse(rsp)
}

// ParseListMetadataRecordsResponse parses an HTTP response from a ListMetadataRecordsWithResponse call
func ParseListMetadataRecordsResponse(rsp *http.Response) (*ListMetadataRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ListMetadataRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest struct {
			// Records List of metadata records
			Records []Metadata `json:"records"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseCreateMetadataRecordsResponse parses an HTTP response from a CreateMetadataRecordsWithResponse call
func ParseCreateMetadataRecordsResponse(rsp *http.Response) (*CreateMetadataRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateMetadataRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseGetHealthResponse parses an HTTP response from a GetHealthWithResponse call
func ParseGetHealthResponse(rsp *http.Response) (*GetHealthResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetHealthResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ParseGetLogRecordsResponse parses an HTTP response from a GetLogRecordsWithResponse call
func ParseGetLogRecordsResponse(rsp *http.Response) (*GetLogRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetLogRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest struct {
			Pagination PaginationResult `json:"pagination"`

			// Records List of log records
			Records []LogRecord `json:"records"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseCreateLogRecordsResponse parses an HTTP response from a CreateLogRecordsWithResponse call
func ParseCreateLogRecordsResponse(rsp *http.Response) (*CreateLogRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateLogRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// get Metadata records of a Transaction
	// (GET /metadata/{transactionID})
	ListMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid)
	// create new Metadata records
	// (PUT /metadata/{transactionID})
	CreateMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid)
	// health endpoint for the Transaction log API
	// (GET /v1/health)
	GetHealth(w http.ResponseWriter, r *http.Request)
	// Returns logs
	// (GET /v1/logs)
	GetLogRecords(w http.ResponseWriter, r *http.Request, params GetLogRecordsParams)
	// Create new Log records
	// (POST /v1/logs)
	CreateLogRecords(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// get Metadata records of a Transaction
// (GET /metadata/{transactionID})
func (_ Unimplemented) ListMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid) {
	w.WriteHeader(http.StatusNotImplemented)
}

// create new Metadata records
// (PUT /metadata/{transactionID})
func (_ Unimplemented) CreateMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid) {
	w.WriteHeader(http.StatusNotImplemented)
}

// health endpoint for the Transaction log API
// (GET /v1/health)
func (_ Unimplemented) GetHealth(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Returns logs
// (GET /v1/logs)
func (_ Unimplemented) GetLogRecords(w http.ResponseWriter, r *http.Request, params GetLogRecordsParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Create new Log records
// (POST /v1/logs)
func (_ Unimplemented) CreateLogRecords(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// ListMetadataRecords operation middleware
func (siw *ServerInterfaceWrapper) ListMetadataRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "transactionID" -------------
	var transactionID Uuid

	err = runtime.BindStyledParameterWithOptions("simple", "transactionID", chi.URLParam(r, "transactionID"), &transactionID, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "transactionID", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ListMetadataRecords(w, r, transactionID)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateMetadataRecords operation middleware
func (siw *ServerInterfaceWrapper) CreateMetadataRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "transactionID" -------------
	var transactionID Uuid

	err = runtime.BindStyledParameterWithOptions("simple", "transactionID", chi.URLParam(r, "transactionID"), &transactionID, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "transactionID", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateMetadataRecords(w, r, transactionID)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetHealth operation middleware
func (siw *ServerInterfaceWrapper) GetHealth(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetHealth(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetLogRecords operation middleware
func (siw *ServerInterfaceWrapper) GetLogRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetLogRecordsParams

	// ------------- Optional query parameter "cursor" -------------

	err = runtime.BindQueryParameter("form", true, false, "cursor", r.URL.Query(), &params.Cursor)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "cursor", Err: err})
		return
	}

	// ------------- Optional query parameter "limit" -------------

	err = runtime.BindQueryParameter("form", true, false, "limit", r.URL.Query(), &params.Limit)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "limit", Err: err})
		return
	}

	// ------------- Optional query parameter "sort_order" -------------

	err = runtime.BindQueryParameter("form", true, false, "sort_order", r.URL.Query(), &params.SortOrder)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sort_order", Err: err})
		return
	}

	// ------------- Optional query parameter "after" -------------

	err = runtime.BindQueryParameter("form", true, false, "after", r.URL.Query(), &params.After)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "after", Err: err})
		return
	}

	// ------------- Optional query parameter "before" -------------

	err = runtime.BindQueryParameter("form", true, false, "before", r.URL.Query(), &params.Before)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "before", Err: err})
		return
	}

	// ------------- Required query parameter "group_id" -------------

	if paramValue := r.URL.Query().Get("group_id"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "group_id"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "group_id", r.URL.Query(), &params.GroupId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "group_id", Err: err})
		return
	}

	// ------------- Optional query parameter "grant_hash" -------------

	err = runtime.BindQueryParameter("form", false, false, "grant_hash", r.URL.Query(), &params.GrantHash)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "grant_hash", Err: err})
		return
	}

	// ------------- Optional query parameter "service_name" -------------

	err = runtime.BindQueryParameter("form", false, false, "service_name", r.URL.Query(), &params.ServiceName)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "service_name", Err: err})
		return
	}

	// ------------- Optional query parameter "transaction_ids" -------------

	err = runtime.BindQueryParameter("form", false, false, "transaction_ids", r.URL.Query(), &params.TransactionIds)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "transaction_ids", Err: err})
		return
	}

	// ------------- Optional query parameter "peer_id" -------------

	err = runtime.BindQueryParameter("form", false, false, "peer_id", r.URL.Query(), &params.PeerId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "peer_id", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetLogRecords(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateLogRecords operation middleware
func (siw *ServerInterfaceWrapper) CreateLogRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateLogRecords(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/metadata/{transactionID}", wrapper.ListMetadataRecords)
	})
	r.Group(func(r chi.Router) {
		r.Put(options.BaseURL+"/metadata/{transactionID}", wrapper.CreateMetadataRecords)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/health", wrapper.GetHealth)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/logs", wrapper.GetLogRecords)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/v1/logs", wrapper.CreateLogRecords)
	})

	return r
}

type N400BadRequestApplicationProblemPlusJSONResponse Error

type N401UnauthorizedApplicationProblemPlusJSONResponse Error

type N403ForbiddenApplicationProblemPlusJSONResponse Error

type N404NotFoundApplicationProblemPlusJSONResponse Error

type N408RequestTimeoutApplicationProblemPlusJSONResponse Error

type N413PayloadTooLargeApplicationProblemPlusJSONResponse Error

type N414URITooLongApplicationProblemPlusJSONResponse Error

type N422UnprocessableEntityApplicationProblemPlusJSONResponse Error

type N429TooManyRequestsApplicationProblemPlusJSONResponse Error

type N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse Error

type N500InternalServerErrorApplicationProblemPlusJSONResponse Error

type N503ServiceUnavailableApplicationProblemPlusJSONResponse Error

type N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse Error

type ListMetadataRecordsRequestObject struct {
	TransactionID Uuid `json:"transactionID"`
}

type ListMetadataRecordsResponseObject interface {
	VisitListMetadataRecordsResponse(w http.ResponseWriter) error
}

type ListMetadataRecords200JSONResponse struct {
	// Records List of metadata records
	Records []Metadata `json:"records"`
}

func (response ListMetadataRecords200JSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords400ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords401ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords403ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords404ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords408ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords413ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords414ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords422ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords429ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords431ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords500ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords503ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type ListMetadataRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response ListMetadataRecords505ApplicationProblemPlusJSONResponse) VisitListMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecordsRequestObject struct {
	TransactionID Uuid `json:"transactionID"`
	Body          *CreateMetadataRecordsJSONRequestBody
}

type CreateMetadataRecordsResponseObject interface {
	VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error
}

type CreateMetadataRecords204Response struct {
}

func (response CreateMetadataRecords204Response) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type CreateMetadataRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords400ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords401ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords403ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords408ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords413ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords414ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords422ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords429ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords431ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords500ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords503ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type CreateMetadataRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response CreateMetadataRecords505ApplicationProblemPlusJSONResponse) VisitCreateMetadataRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type GetHealthRequestObject struct {
}

type GetHealthResponseObject interface {
	VisitGetHealthResponse(w http.ResponseWriter) error
}

type GetHealth200Response struct {
}

func (response GetHealth200Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(200)
	return nil
}

type GetHealth503Response struct {
}

func (response GetHealth503Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(503)
	return nil
}

type GetLogRecordsRequestObject struct {
	Params GetLogRecordsParams
}

type GetLogRecordsResponseObject interface {
	VisitGetLogRecordsResponse(w http.ResponseWriter) error
}

type GetLogRecords200JSONResponse struct {
	Pagination PaginationResult `json:"pagination"`

	// Records List of log records
	Records []LogRecord `json:"records"`
}

func (response GetLogRecords200JSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response GetLogRecords400ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response GetLogRecords401ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response GetLogRecords403ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response GetLogRecords404ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response GetLogRecords408ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response GetLogRecords413ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response GetLogRecords414ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response GetLogRecords422ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response GetLogRecords429ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response GetLogRecords431ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response GetLogRecords500ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response GetLogRecords503ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type GetLogRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response GetLogRecords505ApplicationProblemPlusJSONResponse) VisitGetLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecordsRequestObject struct {
	Body *CreateLogRecordsJSONRequestBody
}

type CreateLogRecordsResponseObject interface {
	VisitCreateLogRecordsResponse(w http.ResponseWriter) error
}

type CreateLogRecords204Response struct {
}

func (response CreateLogRecords204Response) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type CreateLogRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords400ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords401ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords403ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords408ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords413ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords414ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords422ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords429ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords431ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords500ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords503ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type CreateLogRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response CreateLogRecords505ApplicationProblemPlusJSONResponse) VisitCreateLogRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// get Metadata records of a Transaction
	// (GET /metadata/{transactionID})
	ListMetadataRecords(ctx context.Context, request ListMetadataRecordsRequestObject) (ListMetadataRecordsResponseObject, error)
	// create new Metadata records
	// (PUT /metadata/{transactionID})
	CreateMetadataRecords(ctx context.Context, request CreateMetadataRecordsRequestObject) (CreateMetadataRecordsResponseObject, error)
	// health endpoint for the Transaction log API
	// (GET /v1/health)
	GetHealth(ctx context.Context, request GetHealthRequestObject) (GetHealthResponseObject, error)
	// Returns logs
	// (GET /v1/logs)
	GetLogRecords(ctx context.Context, request GetLogRecordsRequestObject) (GetLogRecordsResponseObject, error)
	// Create new Log records
	// (POST /v1/logs)
	CreateLogRecords(ctx context.Context, request CreateLogRecordsRequestObject) (CreateLogRecordsResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// ListMetadataRecords operation middleware
func (sh *strictHandler) ListMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid) {
	var request ListMetadataRecordsRequestObject

	request.TransactionID = transactionID

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ListMetadataRecords(ctx, request.(ListMetadataRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ListMetadataRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ListMetadataRecordsResponseObject); ok {
		if err := validResponse.VisitListMetadataRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateMetadataRecords operation middleware
func (sh *strictHandler) CreateMetadataRecords(w http.ResponseWriter, r *http.Request, transactionID Uuid) {
	var request CreateMetadataRecordsRequestObject

	request.TransactionID = transactionID

	var body CreateMetadataRecordsJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateMetadataRecords(ctx, request.(CreateMetadataRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateMetadataRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateMetadataRecordsResponseObject); ok {
		if err := validResponse.VisitCreateMetadataRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetHealth operation middleware
func (sh *strictHandler) GetHealth(w http.ResponseWriter, r *http.Request) {
	var request GetHealthRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetHealth(ctx, request.(GetHealthRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetHealth")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetHealthResponseObject); ok {
		if err := validResponse.VisitGetHealthResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetLogRecords operation middleware
func (sh *strictHandler) GetLogRecords(w http.ResponseWriter, r *http.Request, params GetLogRecordsParams) {
	var request GetLogRecordsRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetLogRecords(ctx, request.(GetLogRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetLogRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetLogRecordsResponseObject); ok {
		if err := validResponse.VisitGetLogRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateLogRecords operation middleware
func (sh *strictHandler) CreateLogRecords(w http.ResponseWriter, r *http.Request) {
	var request CreateLogRecordsRequestObject

	var body CreateLogRecordsJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateLogRecords(ctx, request.(CreateLogRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateLogRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateLogRecordsResponseObject); ok {
		if err := validResponse.VisitCreateLogRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xb61PbOLT/VzTafmhnTQhvyjdKKM0sBS6EvbvTMlSxT2x1bcmV5IRsh//9zpFkx04c",
	"CN1d7u4MHzpDrMd56JyfzkP9TkOZ5VKAMJoefKc5UywDA8r++laAml6wmAtmuBRHhdJS4UAEOlQ8x4/0",
	"gB6S0I6QkZIZmSQ8TEjuVkFEFOgiNZroRBZpRIZAFJhCCYg65BTYGAhkuZmSkVTEJEBGXGmD64EGlOP+",
	"lg0aUMEyoAfUEaMB1WECGUN+zDTHEW0UFzG9vw/mWT/lGTeLnA8SIBm741mREVFkQ1BEjkqOl5BP7VZ1",
	"6hGMWJEaerC5E9CRVBkz9IAWXJitTRpQT4AebHS73YBmXPifQck3FwZiUG2Mn6sIVDvjWirDRUwkTkG+",
	"UXsP845Lbu38hgCvFIzoAf1pfWYM625Ur+MSx8Q9sqdA51JosPax3e2+Y9ElfCtAW+2GUhgQ9k+W5ykP",
	"rQzruZLDFLKfv2pk/vuKlEEp6ak2hX/HIuKJBuQ1dOJOQDKWouatvdkRoqfCsLuAaP4nECMlSZmKISBc",
	"jFnKZ/My0JrFQEaKZVzEAZGKRBBCbvgYqllKFqjsNx16H9Dt7sa1YIVJpOJ/QvR8ktepBva8Cw2KRBI0",
	"EdKQBN3JiYcTQRjPCAkVRPiTpbryNIMKMWgyslAheNG23ks15FEE4vnkqkguFQo/56AyrjWKYySBOwgL",
	"gyNcl8fkJNg+k+a9LMQzHsyZNMSSDLwXWnYc+lnlktCiH8ozBDLCqV7f+96UBzwDWTyjG3m6xBN2nIcp",
	"B2FIxB2vuZJREQJhlSNMuEm4cPbDM1Q/M/aXBjUGRSZMk1xBzhREeEwTxo2TdGPrgk1TyaKBlKdoes8n",
	"qidMBlKSUwcDtWMiXDtwQLdgoi4N12TC09TBLGHDFKEEtRKC1l6s7evLPookRfyMSHDZd9JIhCzkGL/k",
	"So55BJE9BYt5UsSVv3uZ5gXY3LwW/gMKeCwMN9PnxLQaceKoN48HhZlAmq55hB8W7lshygOxLpWmcgIR",
	"iQr7SUPGEP6IJVyK+nYg5Ucmpt729fOJiYeFlMubS9egLmGaaHQ7PLIMJ3nRNeGCMBLzMQjCMlkIYy96",
	"nnm03trw230AFoF6zyGN9PP7Vwkljgvi2Jj3tplLFaJ0qpktNk58CCErNBDgJgFFmCBcRHzMo4KlJHFE",
	"RkjE3tYsTe3q+oAmoUxTCPEST6cBYaoWBFjd7XS7fWFACZZeWc6OrXTPprOSOHHUiSUf4GmDAFUabhme",
	"BN4IJglagiCFgLscQrxiQikibi95dAoQIZoJIPwygShOMqmA6BxCPuJhFe9wTXTBDbqQ18cWcsJDuBZs",
	"zHiKI8+nDk+b1Ig3zCZkwgUDIkqhYSyvS2vhFsnlGBSCPUQ2kpMTYQEwYxhlCyZCeNMhJ6hjlqYWabjG",
	"dYwYyHKpmJoSbZgptbLzYTC4+BUUxh1n0lwVeS6Vec6oDxkgngOCkUbFQ0NDVcCk3bAds2vHfm2hISL+",
	"8vba69ikw7Pg8wzjc4/FtKMHhvFUl8nGBdjEYwTK+nICxJ8iDWiuZA7KcJcpaPf9NgdQtzx6TBU4rd9D",
	"/bsM6eHZNZYHON3lKd8KrvCUPrk9ggUebqr8Sw6/QmiDx9pWPUghZv6gf0wN1gHxt9/LZq1NxUTlyNNV",
	"82/UadAi0CN6HnhuQGBS/In2jq8G/bPDQf/87Hbw+8Xxbe0DDdqGT49PDgfHvcbEGdGyKBBQKAG+eZoW",
	"eInjjbAwlCryV9Ony/dH5O32zt7N68SYXB+sr08mk44ahWsQcSNVR6p4XY1C/IfzOonJ0jcth2ztZZH0",
	"hyJjYk0Bi2wkA3d5ypxWZnhtpIMoGYaFUiBCKO3Ow0znsxgkQD57Mp8pcSIHhI8wFMfIIiCyiBMMMMhI",
	"hoUmUpAE0rw0WB/2h1Ip1EJt94AoZi9hGxrHfIxLIhgWcYx/ceEKHlyKzmdBW7TOhTaIuovSY8SqYARO",
	"KJtIcJukjji4eKBSwnLh20gifBdt6kYwdIMklBG4q9ZWqYZTu6tUPOaiRFQXOD+o+3p9Z+ft23p5p9td",
	"LPAE1HCTtujiKpHKBCRpGoQusgzvoyZRgru2Cl569lP1/MjGS3zfabkUKajMvHbmN/cBjRUT5gPTSXsZ",
	"K2E6QQEZOcGJNKBwx7IclURfbbzafvXzxf/09ybQ3fjWHx1Pvm2f71xzefrLn19P3sWXY7b7fufn4fWo",
	"l/5yd/01/H1n+tvGx0stds9++Vb0hqf7v4Z/pMnv52/1Hxv76kNv95RtTdaz2B3cKYjYJHhYm9st+oyV",
	"LPJ+r53x91dH5AQnkH6PvO5x9BypppiIvWlI4f/qjHTYCWXWdnCpjC8BkaetuprKmCg3Oo8soQI031tm",
	"HgN0zBm0YVk+B7+WIEeCGX5xAJmxHKEB/1wRbx+/Rmb3afAwxj++FYrg9TA9c5VNq9H7gEoB5yN68Gnl",
	"243eByvPnYlwj4Yd2SNvDZTQPqphZ91lwEX6HehgwNlMeBBMNQgbtCoIgY+tpqpbsX95fGT11T87Ov/Y",
	"PztBNVYfz68HJ+f48abVipkwt4n3wIdknblqafwrBBalk9RCEldufqSw7Oba88Oltkz2mDVenV9fHh3P",
	"G6L7uryCjTvXza++yypr/7K9VdusMm3OyoxiQjNrSCscRlHwaBGwm1vUjrZuxA1DqQ6kCRZzRxzUAagt",
	"zsvAsIgZm/uwyKWpLL1oYNjCorng6T/jZU92l7/haJec5NzObUeTVz2mS9szsu2/huYF3Jnb8LGmn40n",
	"QibIEFyCaSRRYBQHX7bHbWw/z9ZqhG/3OcVhiIrRJdgCTVmrmDWxHg5E6gy2iuhSnla76fecwWDy1rit",
	"Nza3tnd29/bfdqu/NprBwqbr4lWxQ1sEWgO3VvLoPo4BXaXMMx4UE5HMbud8rc7Czk6Dh602HqrOXSsH",
	"rm3IhW/Y1pqHLa3amo9cnV8Obs8ve8eXt4dXR8dnPecltc+94+r7TStfFdI/mlVzwQ1npkxTyjbPPEbI",
	"wkzY9J/JhB27DyXBc9TbLHEe2f+C8P9sUeFfpclVqwm1jWuFhJZbPng4gGiz1lnc3AKB14LfkdmMmgtv",
	"7O5t7mzu7WISWD0J4MLsbtNajtiaIVqcX0zirvs9Mt5rwER3Y//taA921sL9/a21vY3u7tr+5t7mWhgO",
	"90bhkHV39naauLG124SN3UWItSn7SLaAxm/kVMbk8vhqQA4v+p/FZ3HUhH0XDFgDrW6AVMbaVwZc5lvu",
	"c3jRpwH1pUnE3U6307UmmINgOacHdKvT7WyhdTOTWMNeL+OJ9e+1G67fu8fBGOwdho5gr7V+RA/oKdfm",
	"o1/kMixtN5w9c/k0L2dj59m7ihJ57LsK5Gj2rKKxgtYt26gCVn1p4e/3m7lHFpvd7gOl5sUScxMKlJd5",
	"4TRRMShcqVGiKu1wA5l+jNsqsqucnzKl2HTBtct9Fx13sdJ9WmW62jXHu8vYqFS03nyE4l5nrLKq+YTD",
	"PX1YZV3tfYR7bbDKotmTBNfzX2XN/MMA10NfYeVio931qVdZWm9mu+bwCqvaO8iu4brK8oWurGttrrD0",
	"4f6n6/I9vs2SVqBriq2yvK1z5ppHq6xe2mGyrRlXAqQHiG/k45y3uhByMMMfxFkWI6xVudetxAjbluLy",
	"ogUijyxq/wdB0hJ7J6PpP4mPH/9/8bGppfuFu2G7hfMZiPobOfrPgOkLML4A45OB0YedAiZt3roUDu8D",
	"uj7eWE+ApSZZGkCeAKowtUjWFpfNxcgzkLNl+8OLPuGaOBrTmuJWWlaIamFDYPeVgIhyyYWpHni1bFNT",
	"gI+r5+XHAP0h6U/L1kTLndB2gLMp6+3vx5dVQZcvdK+3n77Ov1sOHkLICTcJYQ4oUW+RzWBGBnzrb8zS",
	"AuwjwLl6SNv7artu5afVtZbMD/A4hJFU8ANMuoV/D5cn4JrFaY3bqmtqa5OdJVzUCpc/FglUddRFrg5J",
	"6m9v21K0LUawPW9f65JkxFMDqkP+NwFBsiI1PE/Bf9W2GOmSWhvV+FOwdUr/JG326IprgmwvKZrd5amM",
	"gB6MWKphmSbqVfdK9pWijEbDphlmBFSbqU24R1Jl9CEt+TqjLUr+a9U0Vwx9oqLmuk0/rKpaFEv6vQeU",
	"ZT3AikAqgLJv7rzHzMrvs3FtSycWnysdz/TFYyHVyupqdgD00zXmIu2/oKocQC3R0YoyzOqAT+R9vi65",
	"jPu/t9YyO9JH+ZvvvdjA/pFMpIaxqyYhs2cFq2Yh9b7Qk0s2AU25+KNFF4vdhy+13s0Xf3+VgDB7ouiO",
	"ptFdYq6l96VcuuBignw5OR6QMrT54oqPzbAmtmHNfEDj/8Nbp2x5oWodB52hjKY/1Y5tvd56urdqeSlW",
	"veRkLzlZmaJcWl/Wtvxfy0FSaZ8NumKU1EurUY2k45kqPc+Cry9VnhdEeUGUH0GUo1mVpxlzLK1v+HcY",
	"ZbGiUCk9oOVD7u/mLpXxtUrvD7a3t2hAx0xx5Ny9SfKDjf/eTVMZsjSRtsI9/8T2tCyC19qb9zY3baNb",
	"1qks/f1lDNRm/TgjVUnMc3RTaex79V/aPSoH9G4t4jpPWfnMrRxBOfzkppoXl7jvtQVzhbelK25wxLDY",
	"vqlt8NfoGM9fJcHCwc9Il7I/VAa8uf+/AAAA//+SyJt8BUEAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
